/*
 * Copyright (c) 2009 Nokia Corporation and/or its subsidiary(-ies).
 * All rights reserved.
 * This component and the accompanying materials are made available
 * under the terms of "Eclipse Public License v1.0"
 * which accompanies this distribution, and is available
 * at the URL "http://www.eclipse.org/legal/epl-v10.html".
 * 
 * Initial Contributors:
 * Nokia Corporation - Initial contribution
 * 
 * Contributors:
 * 
 * Description: This file is part of com.nokia.tools.vct.confml component.
 */

package com.nokia.tools.vct.confml.model.confml1;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see com.nokia.tools.vct.confml.model.confml1.EConfML1Package
 * @generated
 */
public interface EConfML1Factory extends EFactory {
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	EConfML1Factory eINSTANCE = com.nokia.tools.vct.confml.model.confml1.impl.EConfML1FactoryImpl
			.init();

	/**
	 * Returns a new object of class '<em>EConfiguration Element</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>EConfiguration Element</em>'.
	 * @generated
	 */
	EConfigurationElement createEConfigurationElement();

	/**
	 * Returns a new object of class '<em>EFeature Element</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>EFeature Element</em>'.
	 * @generated
	 */
	EFeatureElement createEFeatureElement();

	/**
	 * Returns a new object of class '<em>EFeature Data</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>EFeature Data</em>'.
	 * @generated
	 */
	EFeatureData createEFeatureData();

	/**
	 * Returns a new object of class '<em>ESetting Element</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>ESetting Element</em>'.
	 * @generated
	 */
	ESettingElement createESettingElement();

	/**
	 * Returns a new object of class '<em>ESetting Data</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>ESetting Data</em>'.
	 * @generated
	 */
	ESettingData createESettingData();

	/**
	 * Returns a new object of class '<em>EView Element</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>EView Element</em>'.
	 * @generated
	 */
	EViewElement createEViewElement();

	/**
	 * Returns a new object of class '<em>EGroup</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>EGroup</em>'.
	 * @generated
	 */
	EGroup createEGroup();

	/**
	 * Returns a new object of class '<em>EFeature Rfs</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>EFeature Rfs</em>'.
	 * @generated
	 */
	EFeatureRfs createEFeatureRfs();

	/**
	 * Returns a new object of class '<em>ESetting Rfs</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>ESetting Rfs</em>'.
	 * @generated
	 */
	ESettingRfs createESettingRfs();

	/**
	 * Returns a new object of class '<em>EMeta Element</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>EMeta Element</em>'.
	 * @generated
	 */
	EMetaElement createEMetaElement();

	/**
	 * Returns a new object of class '<em>EOption Element</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>EOption Element</em>'.
	 * @generated
	 */
	EOptionElement createEOptionElement();

	/**
	 * Returns a new object of class '<em>EProperty Element</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>EProperty Element</em>'.
	 * @generated
	 */
	EPropertyElement createEPropertyElement();

	/**
	 * Returns a new object of class '<em>EDescription Element</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>EDescription Element</em>'.
	 * @generated
	 */
	EDescriptionElement createEDescriptionElement();

	/**
	 * Returns a new object of class '<em>EIcon Element</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>EIcon Element</em>'.
	 * @generated
	 */
	EIconElement createEIconElement();

	/**
	 * Returns a new object of class '<em>ELink Element</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>ELink Element</em>'.
	 * @generated
	 */
	ELinkElement createELinkElement();

	/**
	 * Returns a new object of class '<em>EData Element</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>EData Element</em>'.
	 * @generated
	 */
	EDataElement createEDataElement();

	/**
	 * Returns a new object of class '<em>ERfs Element</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>ERfs Element</em>'.
	 * @generated
	 */
	ERfsElement createERfsElement();

	/**
	 * Returns a new object of class '<em>ECommon Attrs</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>ECommon Attrs</em>'.
	 * @generated
	 */
	ECommonAttrs createECommonAttrs();

	/**
	 * Returns a new object of class '<em>EMeta Content</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>EMeta Content</em>'.
	 * @generated
	 */
	EMetaContent createEMetaContent();

	/**
	 * Returns a new object of class '<em>ERef Named Element</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>ERef Named Element</em>'.
	 * @generated
	 */
	ERefNamedElement createERefNamedElement();

	/**
	 * Returns a new object of class '<em>EConf ML Document</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>EConf ML Document</em>'.
	 * @generated
	 */
	EConfMLDocument createEConfMLDocument();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	EConfML1Package getEConfML1Package();

} //EConfML1Factory
